/*
 * 
 * Copyright 2004 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun Community Source
 * License v3.0/Jini Technology Specific Attachment v 1.0 (the
 * "License"). You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://wwws.sun.com/software/jini/licensing/SCSL3_JiniTSA1.html.
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Reference Code is Jini Technology Core Platform code, v2.0. The
 * Developer of the Reference Code is Sun Microsystems, Inc.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * The contents of this file comply with the Jini Technology Core
 * Platform Compatibility Kit, v2.0A.
 * 
 * Tester(s): Sun Microsystems, Inc.
 * 
 * Test Platform(s):
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Solaris(TM)SPARC/x86
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Linux (Intel x86)
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Windows (Intel Platform)
 * 
 */

package com.sun.jini.discovery.kerberos;

import com.sun.jini.discovery.internal.EndpointBasedClient;
import java.security.Principal;
import java.util.Iterator;
import java.util.Set;
import javax.net.SocketFactory;
import javax.security.auth.kerberos.KerberosPrincipal;
import net.jini.core.constraint.InvocationConstraint;
import net.jini.core.constraint.InvocationConstraints;
import net.jini.core.constraint.ServerMinPrincipal;
import net.jini.io.UnsupportedConstraintException;
import net.jini.jeri.Endpoint;
import net.jini.jeri.kerberos.KerberosEndpoint;

/**
 * Implements the client side of the <code>net.jini.discovery.kerberos</code>
 * unicast discovery format.
 *
 * @author Sun Microsystems, Inc.
 * @since 2.0
 */
public class Client extends EndpointBasedClient {

    /**
     * Creates a new instance.
     */
    public Client() {
	super("net.jini.discovery.kerberos", EndpointInternalsAccess.get());
    }

    // documentation inherited from EndpointBasedClient
    protected Endpoint getEndpoint(SocketFactory factory,
				   InvocationConstraints constraints)
	throws UnsupportedConstraintException
    {
	return KerberosEndpoint.getInstance(
	    "ignored", 1, getKerberosPrincipal(constraints), factory);
    }

    /**
     * Returns the kerberos principal specified in the ServerMinPrincipal
     * requirements or preferences of the given constraints.  Throws
     * UnsupportedConstraintException if no kerberos principal is specified, a
     * non-kerberos server principal is required, or multiple server principals
     * are required.
     */
    private static KerberosPrincipal getKerberosPrincipal(
					    InvocationConstraints constraints)
	throws UnsupportedConstraintException
    {
	KerberosPrincipal principal = null;
	for (Iterator i = constraints.requirements().iterator(); i.hasNext(); )
	{
	    InvocationConstraint c = (InvocationConstraint) i.next();
	    if (c instanceof ServerMinPrincipal) {
		Set s = ((ServerMinPrincipal) c).elements();
		if (s.size() > 1) {
		    throw new UnsupportedConstraintException(
			"multiple server principals");
		}
		Principal p = (Principal) s.iterator().next();
		if (!(p instanceof KerberosPrincipal)) {
		    throw new UnsupportedConstraintException(
			"non-kerberos server principal");
		}
		if (principal == null) {
		    principal = (KerberosPrincipal) p;
		} else if (!principal.equals(p)) {
		    throw new UnsupportedConstraintException(
			"multiple server principals");
		}
	    }
	    // NYI: support ConstraintAlternatives with ServerMinPrincipals
	}
	if (principal != null) {
	    return principal;
	}
	for (Iterator i = constraints.preferences().iterator(); i.hasNext(); )
	{
	    InvocationConstraint c = (InvocationConstraint) i.next();
	    if (c instanceof ServerMinPrincipal) {
		Set s = ((ServerMinPrincipal) c).elements();
		for (Iterator j = s.iterator(); j.hasNext(); ) {
		    Principal p = (Principal) j.next();
		    if (p instanceof KerberosPrincipal) {
			return (KerberosPrincipal) p;
		    }
		}
	    }
	    // NYI: support ConstraintAlternatives with ServerMinPrincipals
	}
	throw new UnsupportedConstraintException("no kerberos principal");
    }
}
